<template>
  <div :id="`element-${elementId}`"
       v-if="wrapInElement"
       class="sw-gs-cms-element-wrapper"
       :class="{ 'is-highlighted': elementIsHighlighted }"
       @touchstart.passive="() => publishHoverStart(500)"
       @touchend.passive="() => publishHoverEnd()"
       @mouseenter.self="() => publishHoverStart()"
       @mouseleave="() => publishHoverEnd()"
       @click="publishHover"
  >
    <slot />

    <div class="sw-gs-cms-element-actions is-vertical-mobile sw-gs-nav-overlay"
         v-if="isGuide && !isSelfService"
         :class="{
             'sw-gs-cms-element-actions__active is-quickview-count': quickViewUserCount > 0,
             'sw-gs-outer-position': slotContext && slotContext.type === 'cross-selling'
         }">

      <slot name="actions" v-bind="{slotContext, actionsVisible, quickViewUserCount, elementHighlightLoading, scrollToIsLoading}">
        <SwButton v-if="quickViewUserCount > 0"
                  class="sw-gs-quickview-count-btn color-light is-circle"
                  :title="$t('Users viewing this item')"
                  :disabled="true">
          <span class="sw-gs-quickview-count-badge">{{quickViewUserCount}}</span>
          <SwGsIconEye class="color-dark-secondary size-sm"/>
        </SwButton>

        <SwButton class="sw-gs-show-actions-btn color-light is-circle"
                  :title="$t('Users viewing this item')"
                  @click="toggleActions">
          <SwGsIconDotDotDot class="color-dark-secondary size-sm"/>
        </SwButton>

        <SwButton class="sw-gs-get-client-btn color-light is-circle visible-on-hover"
                  v-bind:class="{'visible': actionsVisible}"
                  :title="$t('Get client')"
                  @click="handlePublishScrollTo"
                  :disabled="elementHighlightLoading">
          <SfLoader :loading="scrollToIsLoading">
            <SwGsIconGetClients class="color-dark-secondary size-sm"/>
          </SfLoader>
        </SwButton>
        <SwButton class="sw-gs-highlight-btn color-light is-circle visible-on-hover"
                  v-bind:class="{'visible': actionsVisible}"
                  :title="$t('Highlight')"
                  @click="publishHighlightElement"
                  :disabled="scrollToIsLoading || scrollToIsLoadingBlock">
          <SfLoader :loading="elementHighlightLoading">
            <SwGsIconHighlight class="color-dark-secondary size-sm"/>
          </SfLoader>
        </SwButton>
        <SwButton v-if="productId" class="sw-gs-layer-guide-product-like-toggle color-light is-circle visible-on-hover"
                :title="productOnGuideList ? $t('Remove from guide product list') : $t('Add to guide product list')"
                :disabled="toggleLikeLoading"
                @click.stop="toggleGuideLike">
          <SfLoader :loading="toggleLikeLoading" class="sw-gs-layer-product-actions-loader">
            <SwGsIconBookmarkOn v-if="productOnGuideList"
                                class="color-dark-secondary size-sm"/>
            <SwGsIconBookmarkOff v-else
                                class="color-dark-secondary size-sm"/>
          </SfLoader>
        </SwButton>
        <SwButton v-if="productId"
                  class="sw-gs-got-to-pdp-btn color-light is-circle visible-on-hover"
                  v-bind:class="{'visible': actionsVisible}"
                  @click="openDynamicPage({
                    type: 'product',
                    opened: true,
                    productId: productId
                  })"
                  :title="$t('Go to product detail page')">
          <SwGsIconLongArrowRight class="dark-secondary size-sm"/>
        </SwButton>
      </slot>
    </div>
  </div>
  <div v-else>
    <slot/>
  </div>
</template>

<script>
  import SwButton from "@/components/atoms/SwButton.vue";
  import { SfLoader } from "@storefront-ui/vue";
  import { watch, computed, provide, ref, inject } from "@vue/composition-api";
  import { useLikeList } from "../../logic/composables/useLikeList";
  import { useAppointment } from "../../logic/composables/useAppointment";
  import { useHoverElement } from "../../logic/composables/useHoverElement";
  import { useScrollToElement } from "../../logic/composables/useScrollToElement";
  import { useHighlightElement } from "../../logic/composables/useHighlightElement";
  import {
    SwGsIconHighlight,
    SwGsIconGetClients,
    SwGsIconLongArrowRight,
    SwGsIconDotDotDot,
    SwGsIconEye,
    SwGsIconBookmarkOn,
    SwGsIconBookmarkOff
  } from "../icons";
  import { useDynamicPage } from "../../logic/composables/useDynamicPage";
  import { useState } from '../../logic/composables/useState';

  export default {
    name: "CmsGsGenericElement",
    components: {
      SfLoader,
      SwButton,
      SwGsIconHighlight,
      SwGsIconGetClients,
      SwGsIconLongArrowRight,
      SwGsIconDotDotDot,
      SwGsIconEye,
      SwGsIconBookmarkOn,
      SwGsIconBookmarkOff,
    },
    props: {
      slotContext: {
        type: Object | Array | String,
        default: null,
      },
    },
    setup(props, { root }) {
      const { slotContext } = props;
      const layoutName = ref(root.layoutName);
      const disabledElementTypes = ["product-listing", "product-box"];
      let slotContextBlock;
      const useActions = inject("use-guided-shopping-actions", true);
      if (slotContext && slotContext.blockId) {
        provide('slotContextBlock', slotContext);
      }
      const wrapInElement = computed(() => {
        return (
          layoutName.value.includes('PresentationLayout') &&
          slotContext &&
          !disabledElementTypes.includes(slotContext.type) && useActions
        );
      });

      // don't wrap the element if it is not the presentation layout or if the element type is not allowed
      if (!wrapInElement.value) {
        return {
          wrapInElement,
          layoutName,
        };
      }

      const isProduct = slotContext.apiAlias === "product";
      const productId = isProduct ? slotContext.id : null;
      let elementId = '';
      // set the element id here depending on if we're dealing with a product-box or with an emotion element
      if (isProduct && slotContext && slotContext.id) {
        elementId = slotContext.id;
        slotContextBlock = inject('slotContextBlock', null);
        if (slotContextBlock) {
          elementId = [slotContextBlock.blockId + "-" + slotContextBlock.slot, slotContext.id].join('-');
        } else {
          elementId = slotContext.id;
        }
      }
      if (slotContext && slotContext.blockId && slotContext.slot) {
        elementId = slotContext.blockId + "-" + slotContext.slot;
      }
      const { isGuide, isSelfService } = useAppointment();
      const { openDynamicPage } = useDynamicPage();
      const { publishHoverStart, publishHoverEnd, publishHover } = useHoverElement(elementId);
      const { publishScrollTo, scrollToIsLoading } = useScrollToElement(elementId, slotContext);
      const { publishScrollTo: publishScrollToBlock, scrollToIsLoading: scrollToIsLoadingBlock } = useScrollToElement(slotContextBlock ? `${slotContextBlock?.blockId}-${slotContextBlock.slot}` : null, slotContextBlock);
      const { publishHighlightElement, elementIsHighlighted, elementHighlightLoading } = useHighlightElement(elementId);
      const { stateForGuides } = useState();

      const {
        productOnGuideList,
        toggleLikeLoading,
        toggleGuideLike,
      } = useLikeList(isProduct ? slotContext : null);

      const quickViewUserCount = ref(0);

      const getQuickViewUserCount = (state) => {
        if (!state) return;
        const quickViewProduct = state.quickViewState[productId];
        if (quickViewProduct) {
          const quickViewAttendeeIds = Object.keys(state.quickViewState[productId]);

          quickViewAttendeeIds.forEach(id => {
            if (!!state.guides[id])
              delete quickViewProduct[id];
          });

          quickViewUserCount.value = Object.keys(quickViewProduct).length;
        } else {
          quickViewUserCount.value = 0;
        }
      }

      watch(stateForGuides, (newState) => {
        if (isGuide.value) {
          getQuickViewUserCount(newState);
        }
      }, {
        immediate: true
      });

      const actionsVisible = ref(false);

      function toggleActions() {
        actionsVisible.value = !actionsVisible.value;
      }

      const handlePublishScrollTo = async () => {
        if (isProduct && slotContext && slotContext.id && slotContextBlock?.type === 'cross-selling') {
          await publishScrollToBlock();
          setTimeout(() => {
            publishScrollTo();
          }, 800);
        } else {
          publishScrollTo();
        }
      }

      return {
        wrapInElement,
        layoutName,
        productId,
        handlePublishScrollTo,
        publishHighlightElement,
        publishHover,
        publishHoverStart,
        publishHoverEnd,
        isGuide,
        isSelfService,
        elementIsHighlighted,
        scrollToIsLoading,
        scrollToIsLoadingBlock,
        elementHighlightLoading,
        elementId,
        openDynamicPage,
        toggleActions,
        actionsVisible,
        quickViewUserCount,
        productOnGuideList,
        toggleLikeLoading,
        toggleGuideLike
      };
    },
  };
</script>


<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-cms-element-wrapper {
    position: relative;

    @include for-desktop {
      .sw-gs-cms-element-actions {
        .sw-gs-show-actions-btn {
          display: none;
        }
      }

      &:hover {
        & > .sw-gs-cms-element-actions {
          opacity: 1;
          pointer-events: all;

          .visible-on-hover {
            display: block;
          }
        }
      }
    }

    @include for-mobile {
      & > .sw-gs-cms-element-actions {
        opacity: 1;
        pointer-events: all;
        display: block;

        &:focus {
          .visible-on-hover {
            display: block;
          }
        }
      }
    }

    &.is-highlighted {
      & > div:not(.sw-gs-cms-element-actions) {
        box-shadow: 0 4px 35px var(--c-dark);
      }
    }

    &.cms-element-product-card,
    &.product-carousel__product {
      display: block !important;
    }
  }


  .sw-gs-cms-element-actions {
    position: absolute;
    left: 0;
    top: 0;
    z-index: var(--actions-z-index);
    display: flex;
    opacity: 0;
    pointer-events: none;

    &.sw-gs-outer-position {
      transform: translateY(-100%);
    }

    .visible-on-hover {
      &:not(.visible) {
        display: none;
      }
    }

    &__active {
      opacity: 1;
      pointer-events: all;
    }

    &.is-quickview-count {
      z-index: calc(var(--modal-overlay-z-index) - 1); // lay behind modal overlay
    }

    .sw-gs-quickview-count-btn {
      position: relative;

      .sw-gs-quickview-count-badge {
        $badge-size: 18px;
        position: absolute;
        color: var(--c-white);
        background-color: var(--c-primary);
        top: -$badge-size * 0.25;
        right: -$badge-size * 0.25;
        border-radius: 999px;
        min-width: $badge-size;
        min-height: $badge-size;
      }
    }

    ::v-deep {
      .sf-button {
        height: 40px;
        width: 40px;
      }

      .sf-loader {
        width: 22px;
      }

      .sf-loader__overlay {
        background: none;
      }
    }
  }
</style>
